﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
Private Sub Class_Globals
	
	Private Record As List
	Private mAct As Activity
	Private DVPnl As Panel
	Private WV As WebView
	Private ColLut As SLColorLUT
	Private CDMap As Map
	Private TextViews As List
	Private Children()  As String
	Private WebViewDepth As Int = 0
	Private History As List
	Private RequestBack As Boolean

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Act As Activity,DView As String)
	mAct = Act
	DVPnl.Initialize("DVPnl")
	mAct.AddView(DVPnl,Main.PanelLayout.Left,Main.PanelLayout.Top,Main.PanelLayout.Width,Main.PanelLayout.Height)
	WV.Initialize("WV")
	DVPnl.AddView(WV,0,0,100%x,100%y)
	ColLut.Initialize
	History.Initialize
	Show(DView)
End Sub
Sub Show(DView As String)
	
	WebViewDepth = WebViewDepth+1
	DVPnl.Visible=True
	Record = PrepareDB.GetRecord(DView)
	WV.Color = Colors.LightGray
	SetUpCDMap
	TextViews.Initialize
	TextViews.AddAll(Array As String("Label","Button","CheckBox","EditText","RadioButton","ToggleButton"))
	'Don't add to histor if back requested
	If Not(RequestBack) Then History.Add(DView)
	RequestBack = False
	Draw
End Sub
Private Sub Draw

	Dim HTML As String = "<!doctype html>" & CRLF
	HTML = HTML & "<head>" & CRLF
	HTML = HTML & "<style>" & CRLF
	HTML = HTML & "body {font-size:large;}" &CRLF
	HTML = HTML & "h1 {text-align:center;}" & CRLF
	HTML = HTML & "#objName {color:#6600CC;}" & CRLF
	HTML = HTML & "#objType {color:"&ColLut.GetRGBHex(Colors.Cyan)&";}" & CRLF
	HTML = HTML & "#title {font-weight:bold;}" &CRLF
	HTML = HTML & "#exit {position:fixed;top:5px;right:5px; width:30px; height:30px;}" &CRLF
	HTML = HTML & "</style>" & CRLF
	HTML = HTML & "</head>" &CRLF
	HTML = HTML & "<body>" &CRLF
	HTML = HTML & "<a id = ""exit"" href = ""exit""><img src = ""back.jpg"" alt = ""Back"" height = ""30px"" width = ""30px""></a>" &CRLF
	HTML = HTML & "<div id = ""content""> " &CRLF
	HTML =HTML & "<h1>Data for Object </br><span id = ""objName"">"&Record.get(1)&"</span></h1></br>" & CRLF
	HTML =HTML & "<span id = ""title""> Type: </span><span id = ""objType"">"&Record.get(2)&"</span></br>" & CRLF
	'Common data
	HTML =HTML & "<span id = ""title"">Parent:</span> <span id = ""parent"">"
	If Record.Get(4) <> "Activity" Then
		HTML =HTML & "<a id = ""parentLink"" href = "&Record.get(4)&">"&Record.get(4)&"</a>"
	Else
		HTML =HTML & Record.get(4)
	End If
	HTML =HTML & "</span> <span id = ""title"">Tag:</span> <span id = ""tag"">"&Record.get(5)&"</span></br>" & CRLF
	HTML =HTML & "<span id = ""title"">X,Y,W,H:</span> <spam id = ""dimensions"">"&Record.get(6)&","&Record.get(7)&","&Record.get(8)&","&Record.get(9)&"</span></br>" & CRLF
	HTML =HTML & "<span id = ""title"">Enabled:</span> <span id = ""enabled"">"&Record.get(10)&"</span> <span id = ""title"">Visible:</span> <span id = ""visible"">"&Record.get(11)&"</span></br>" & CRLF
	HTML =HTML & "<span id = ""title"">Background Type:</span> <span id = ""backgroundtype"">"&CDMap.get(Record.get(12))&"</span></br>"
	
	If Record.get(12) = "CD" Then
		HTML =HTML & "<span id = ""title"">ColorInt:</span> <span id = ""colorInt"">"&Record.get(13)&"</span> <span id = ""title"">ColorName:</span> <span id = ""colorName"">"&Record.get(14)&"</span></br> <span id = ""title"">ColorAlpha:</span> <span id = ""colorAlpha"">"&Record.get(15)&"</span></br>" & CRLF
	End If
	
	'Variations
	
	'Text Views
	If TextViews.IndexOf(Record.get(2)) <> -1 Then
		HTML =HTML & "<span id = ""title"">Text:</span> <span id = ""text"">"&Record.get(17)&" </span></br>"
		HTML =HTML & "<span id = ""title"">TypeFace:</span> <span id = ""typeFace"">"&Record.get(16)&" </span></br>"
		HTML =HTML & "<span id = ""title"">Text Size:</span> <span id = ""textSize"">"&Record.get(18)&"</span>" & CRLF
		HTML =HTML & "<span id = ""title"">Text Color:</span> <span id = ""textColor"">"&Record.get(19)&" "&Record.get(20)&"</span></br>" & CRLF
		HTML =HTML & "<span id = ""title"">Text Gravity:</span> <span id = ""gravityInt"">"&Record.get(21)&"</span> "
		HTML =HTML & "<span id = ""gravityText"">"&Record.get(22)&"</span></br>" & CRLF
	End If
	'EditText
	If Record.get(2) = "EditText" Then
		HTML =HTML & "<span id = ""title"">TextHint:</span> <span id = ""textHint"">"&Record.get(23)&"</span> <span id = ""title""></br>Hint Color:</span> <span id = ""hintColor"">"&Record.get(24)&"</span> <span id = ""title"">Hint Color Name:</span> <span id = ""hintColorName"">"&Record.get(25)&"</span></br>" & CRLF
		HTML =HTML & "<span id = ""title"">Text Input Type:</span> <span id = ""textInputType"">"&Record.get(26)&"</span> <span id = ""textInputString"">"&Record.get(27)&"</span></br>" & CRLF
	End If
	If Record.get(2) = "ToggleButton" Then
		HTML =HTML & "<span id = ""title"">Checked:</span> <span id = ""tbChecked"">"&Record.get(28)&"</span> <span id = ""title"">Text On:</span> <span id = ""tbTexton"">"&Record.get(29)&"</span> <span id = ""title"">Text Off:</span> <span id = ""tbTextOff"">"&Record.get(30)&"</span></br>" & CRLF
	End If
	If Record.get(2) = "ScrollView" Then
		HTML =HTML & "<span id = ""title"">Inner Width:</span> <span id = ""SVInnerWidth"">"&Record.get(31)&"</span> <span id = ""title"">Inner Height:</span> <span id = ""SVInnerHeight"">"&Record.get(32)&"</span></br>" & CRLF
	End If
	If Record.get(2) = "WebView" Then
		HTML =HTML & "<span id = ""title"">Javascript enabled:</span> <span id = ""JSEnabled"">"&Record.get(33)&"</span> <span id = ""title"">Zoom Enabled</span> <span id = ""zoomEnabled"">"&Record.get(34)&"</span></br>" & CRLF
	End If
	If Record.get(2) = "B4ASpinner" Then
		HTML =HTML & "<span id = ""title"">Prompt:</span> <span id = ""SPPrompt"">"&Record.get(35)&"</span> <span id = ""title"">Prompt Text Size:</span> <span id = ""SPTextSize"">"&Record.get(18)&"</span> <span id = ""title"">Prompt Color:</span> <span id = ""SPPromptColor"">"&Record.get(19)&"</span> <span id = ""title"">Prompt Color Name:</span> <span id = ""SPPromptColorName"">"&Record.get(20)&"</span></br>" & CRLF
	End If
	If Record.get(2) = "ProgressBar" Then
		HTML =HTML & "<span id = ""title"">Indeterminate:</span> <span id = ""PBIndeterminate"">"&Record.get(36)&"</span>"
	End If
	If Record.get(2) = "SeekBar" Then
		HTML =HTML & "<span id = ""title"">Max Value:</span> <span id = ""SBMaxVal"">"&Record.get(37)&"</span> <span id = ""title"">Value</span> <span id = ""SBValue"">"&Record.get(38)&"</span></br>" & CRLF
	End If
	If Record.Get(39) <> "" Then
		HTML = HTML & "<span id = ""title"">Children:</span> "
		Children = Regex.Split(",",Record.Get(39))
		For Each Child As String In Children
			HTML = HTML & "<a id = ""child"" href = """&Child&""">"&Child&" </a> "
		Next
	End If
	
	'Close it down
	HTML = HTML & "</div>"
	HTML = HTML & "</body>"
	Dim JO As JavaObject = WV
	JO.RunMethod("loadDataWithBaseURL",Array As Object("file:///android_asset/",HTML,"text/html","utf-8",Null))
	
	Log(HTML)
End Sub
Sub SetUpCDMap
	CDMap.Initialize
	CDMap.Put("CD","Color Drawable")
	CDMap.Put("GD","Gradient Drawable With Corners")
	CDMap.Put("SLD","State List Drawable")
	CDMap.Put("BD","BitMap Drawable")
End Sub
Sub getWView As WebView
	Return WV
End Sub
Sub Back As Boolean
	RequestBack = True
	If History.Size > 1 Then
		History.RemoveAt(History.Size-1)
		Show(History.Get(History.Size-1))
		Return True
	Else
		Return False
	End If
End Sub
Sub getVisible As Boolean
	Return DVPnl.Visible
End Sub
Sub setVisible(V As Boolean)
	DVPnl.Visible = V
End Sub
Private Sub WV_OverrideUrl (Url As String) As Boolean
	Dim Choice As String = Url.SubString(22)
	If Choice = "exit" Then
		WebViewDepth=0
		DVPnl.Visible=False
		Return True
	End If
	Show(Choice)
	Return True
End Sub