﻿Type=StaticCode
Version=3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private SQL1 As SQL
	Private SU As StringUtils
	Private Headers As List
	Private Data As List
	
End Sub
Sub Initialize
	SQL1.Initialize(File.DirDefaultExternal,"BV.db",True)
	Headers.Initialize
End Sub
Sub ParseCSV(FilePath As String,FileName As String)
	'Load the csv file into a list of arrays (1 per line) and a header list from the first line.
	Data = SU.LoadCSV2(FilePath,FileName,",",Headers)
	CreateDB
End Sub
Sub CreateDB
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS views")
	
	Dim Query As String = "CREATE TABLE views ("
	
	'Create a column for each item in headers
	For Each Name As String In Headers
		Query = Query & Name & " " & "TEXT" &","
	Next
	'Remove the last ","
	Query = Query.SubString2(0,Query.Length-1)
	
	Query = Query & ")"
	
	'Do it
	SQL1.ExecNonQuery(Query)
	
	FillData
End Sub
Sub FillData
	
	Dim InsStr As String
	'Create a string with the appropriate amount of ?'s
	For i = 0 To Headers.Size-1
		InsStr = InsStr & "?,"
	Next
	'Remove the last ","
	InsStr = InsStr.SubString2(0,InsStr.Length-1)
	
	'Load the data
	SQL1.BeginTransaction
	Try
		For Each Line() As String In Data
			SQL1.ExecNonQuery2("INSERT INTO views VALUES("&InsStr&")",Line)
		Next
	SQL1.TransactionSuccessful
	Catch
		Log(LastException.Message)
	End Try
	SQL1.EndTransaction
	
End Sub
Sub getObjectTypes As List
	
	Dim ObjectList As List
	ObjectList.Initialize
	
	Dim Query As String
	Dim Cursor1 As Cursor
	Query = "SELECT ObjectType FROM views"
	Cursor1 = SQL1.ExecQuery(Query)
	
	For i = 0 To Cursor1.RowCount - 1
	Cursor1.Position=i
	ObjectList.Add(Cursor1.GetString("ObjectType"))
	Next
	
	Return ObjectList
End Sub
Sub GetObjectsList(ObjectType As String) As List
	Dim ObjectList As List
	ObjectList.Initialize
	
	Dim Query As String
	Dim Cursor1 As Cursor
	Query = "SELECT ObjectName FROM views WHERE ObjectType = ?"
	Cursor1 = SQL1.ExecQuery2(Query, Array As String(ObjectType))
	
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position=i
		ObjectList.Add(Cursor1.GetString("ObjectName"))
	Next
	
	Return ObjectList
	
End Sub
Sub GetRecord(ObjectName As String) As List

	Dim RecordList As List
	RecordList.Initialize
	
	Dim Query As String
	Dim Cursor1 As Cursor
	Query = "SELECT * FROM views WHERE ObjectName = ?"
	Cursor1 = SQL1.ExecQuery2(Query, Array As String(ObjectName))
	
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position=i
		For j = 0 To Cursor1.ColumnCount-1
			RecordList.Add(Cursor1.GetString2(j))
		Next
	Next
	
	Return RecordList
	
End Sub