﻿Type=StaticCode
Version=3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Private Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private Level As Int = 0
	Private OutList As List
	Private Scale As Double = 1
	Private CustomViewETCount As Int = 0
	Private CustomViewBtnCount As Int = 0
	Private CustomViewRBCount As Int = 0
	Private CustomViewCBCount As Int = 0
	Private CustomViewTBCount As Int = 0
	Private CustomViewHSVCount As Int = 0	
	Private CustomViewSVCount As Int = 0	
	Private CustomViewWVCount As Int = 0
	Private CustomViewSPCount As Int = 0	
	Private CustomViewPBCount As Int = 0	
	Private CustomViewSBCount As Int = 0
	Private CustomViewPanelCount As Int = 0
	Private ProcessedMap As Map
	

End Sub
Sub Process(Act As activity,Root As activity,NamesMap As Map,ObjectsMap As Map)

	OutList.Initialize
	ProcessedMap.Initialize
	
	If Main.RemoveScale Then
		Scale = (1 / Density) * Main.DesignScale
	End If
	
	WriteCSVHeader

	Dim i As Int = 0
	For i = 0 To Root.NumberOfViews-1
		Dim V As View = Root.GetView(i)
		If V Is TabHost Then
			'Process the TabHost
			WriteCSVViews(Act,Root,V,NamesMap,ObjectsMap,Level)
			'Process it's panels
			Dim TH As TabHost = V
			Dim JO As JavaObject = TH
			For j = 0 To TH.TabCount -1
				TH.CurrentTab = j
				Dim O As Object = JO.RunMethod("getCurrentView",Null)
				If O Is Panel Then
					'Check if the panel has been processed as a child of activity before the TabHost is processed
					'and remove it
					Dim Pos As Int = ProcessedMap.GetDefault(NamesMap.Get(O),-1)
					If Pos > -1 Then OutList.RemoveAt(Pos)
					
					'Remove the object from the processed map
					ProcessedMap.Remove(NamesMap.Get(O))
					
					'Renumber the rest of the map if after the removed line
					For k = 0 To ProcessedMap.Size-1
						Dim TestPos As Int = ProcessedMap.GetValueAt(k)
						If TestPos > Pos Then
							ProcessedMap.Put(ProcessedMap.GetKeyAt(k),TestPos-1)
						End If
					Next
					Dim P As Panel = O    
					WriteCSVViews(Act,TH,P,NamesMap,ObjectsMap,Level)
				End If
			Next
		Else
		'Check the object hasn't been procesed, posible for Tabhosts.
			If ProcessedMap.GetDefault(NamesMap.Get(V),-1) = -1 Then 
				WriteCSVViews(Act,Root,V,NamesMap,ObjectsMap,Level)
			End If		
		End If
	Next
	
	StartActivity(Options)
	
	
End Sub
Sub WriteCSVHeader
	Dim Line As String
	Dim CSV As String =QUOTE & "," & QUOTE
	
	Line = QUOTE & "Level" & CSV & "ObjectName" & CSV & "ObjectType" & CSV & "ReportedType" & CSV & "Parent" & CSV & "Tag" & CSV & "X" & CSV & "Y" & CSV & "W" & CSV & "H" & CSV
	Line = Line & "Enabled" & CSV & "Visible" & CSV & "BackgroundType" & CSV & "BackgroundColorInt" & CSV & "BackgroundColorName" & CSV & "BackgroundColorAlpha" & CSV
	Line = Line & "TFace" & CSV & "Text" & CSV & "TextSize" & CSV & "TextColorInt" & CSV & "TextColorName" & CSV & "TextGravity" & CSV & "TextGravityString" & CSV & "TextHint" & CSV & "TextHintColor" & CSV
	Line = Line & "TextHintColorName" & CSV & "TextInputType" & CSV & "TextInputTypeString" & CSV & "BtnChecked" & CSV & "TBTextOn" & CSV & "TBTextOff" & CSV
	Line = Line & "SVInnerWidth" & CSV & "SVInnerHeight" & CSV & "JSEnabled" & CSV & "ZoomEnabled" & CSV & "SPPrompt" & CSV & "PBIndeterminate" & CSV & "SBMaxVal" & CSV & "SBVal" & CSV & "Children" & QUOTE
	
	OutList.Add(Line)
	
End Sub
Sub WriteCSVViews (Act As Activity,mParent As Object,ThisObject As Object,NamesMap As Map,ObjectsMap As Map,mLevel As Int)
	
	Dim V As View = ThisObject
	
	If V.IsInitialized = False Then 
		Log("View "&ThisObject&" Is not initialized, ignored")
		Return
	End If
	
	Dim ReportedType As String = GetType(ThisObject)
	Dim ObjectName As String
	Dim ObjectType As String
	Dim Parent As String
	Dim X,Y,H,W As Int
	Dim Enabled As Boolean
	Dim Visible As Boolean
	Dim Tag As String
	Dim BG As Object 
	Dim BGStr As String
	Dim BackgroundType As String
	Dim BackgroundColorInt As Int
	Dim BackgroundColorName As String
	Dim BackgroundColorAlpha As Int
	Dim ColLUT As SLColorLUT

	Dim TFace As Typeface
	Dim TFaceString As String
	Dim Text As String
	Dim TextSize As Float
	Dim TextColorInt As Int
	Dim TextColorName As String
	Dim TextGravity As Int
	Dim TextGravityString As String
	Dim TextHint As String
	Dim TextHintColor As Int
	Dim TextHintColorName As String
	Dim TextInputType As Int
	Dim TextInputTypeString As String
	Dim BtnChecked As Boolean
	Dim TBTextOn,TBTextOff As String
	
	
	Dim SVInnerWidth As Int
	Dim SVInnerHeight As Int
	Dim JSEnabled As Boolean
	Dim ZoomEnabled As Boolean
	Dim SPPrompt As String
	Dim PBIndeterminate As Boolean
	Dim SBMaxVal As Int
	Dim SBVal As Int
	Dim Children As String
	
	ReportedType = ReportedType.SubString(ReportedType.LastIndexOf(".")+1)
	ObjectName = NamesMap.Get(ThisObject)
	ObjectType = ObjectsMap.GetDefault(ObjectName,"***Not Found***")
	
	'Get the data we need
	
	If mParent = Act Then 
		Parent = "Activity"
	Else
		'Look for the parent in the NameMap created in Main
		Parent = NamesMap.GetDefault(mParent,"Not Found")
	End If
	
	'Exclude  - FrameLayouts for Scrollviews and Linear Layout for TabHost cannot be populated from
	'the designer.
'	If Parent <> "Activity" AND (ReportedType = "BALayout" OR ReportedType = "LinearLayout") AND _
'	(ObjectsMap.Get(Parent) = "HorizontalScrollView" OR ObjectsMap.Get(Parent) = "ScrollView")  Then Return
	
	'Ccheck if its already been processed.  possible for TabHosts
	If ProcessedMap.GetDefault(ObjectName,-1) > -1 Then Return
	
	
	X= V.Left * Scale
	Y=V.Top * Scale
	H=V.Height * Scale
	W=V.Width * Scale
	
	Enabled = V.Enabled
	Visible = V.Visible
	
	Tag = V.Tag
	
	BG = V.Background
	'Determine Background type and if color drawable, get the color
	BGStr = BG

	ColLUT.Initialize

	If BGStr.IndexOf("@") <> -1 Then
		Select BGStr.SubString2(0,BGStr.IndexOf("@"))

			Case "anywheresoftware.b4a.objects.drawable.ColorDrawable$GradientDrawableWithCorners"
				BackgroundType = "GD"
			Case "android.graphics.drawable.StateListDrawable"
				BackgroundType = "SLD"
			Case "android.graphics.drawable.BitmapDrawable"
				BackgroundType = "BD"
			Case "android.graphics.drawable.ColorDrawable"
				BackgroundType = "CD"
				Dim JO As JavaObject = BG
				BackgroundColorInt = JO.RunMethod("getColor",Null)
				BackgroundColorName = ColLUT.GetColorName(BackgroundColorInt)
				BackgroundColorAlpha=ColLUT.GetColorAlpha(BackgroundColorInt)
		End Select
	End If
	
	'Get Text info
	
	Select ReportedType
	
		Case "EditText"
			'Check for CustomView Objects see notes on BALayout
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewETCount = CustomViewETCount + 1
				Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectName = "CVEditText"&NumberFormat(CustomViewETCount,3,0)
				ObjectType = "EditText"
				'And add to the Map
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			End If
			Dim RIT As SLReadInputTypes
			RIT .Initialize
			Dim ET As EditText = V
			TFace = ET.Typeface
			If TFace.IsInitialized Then TFaceString = GetTypefaceString(TFace)
			Text = ET.Text
			TextSize = ET.TextSize
			TextColorInt = ET.TextColor
			TextColorName = ColLUT.GetColorName(TextColorInt)
			TextGravity = ET.Gravity
			TextGravityString = GetGravityString(TextGravity)
			
			TextHint = ET.Hint
			TextHintColor=ET.HintColor
			TextHintColorName = ColLUT.GetColorName(TextHintColor)
			TextInputType = ET.InputType
			TextInputTypeString = RIT.ReadInputTypes(ET.InputType)
			
		Case "Button"
		'Check for CustomView Objects see notes on BALayout
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewBtnCount = CustomViewBtnCount + 1
				Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectName = "CVButton"&NumberFormat(CustomViewBtnCount,3,0)
				ObjectType = "Button"
				'And add to the Map
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			End If
			Dim B As Button = V
			TFace = B.Typeface
			If TFace.IsInitialized Then TFaceString = GetTypefaceString(TFace)
			Text = B.Text
			TextSize = B.TextSize
			TextColorInt = B.TextColor
			TextColorName = ColLUT.GetColorName(TextColorInt)
			TextGravity = B.Gravity
			TextGravityString = GetGravityString(TextGravity)
	
		Case "TextView","RadioButton","CheckBox"
			Dim L As Label = V
			TFace = L.Typeface
			If TFace.IsInitialized Then TFaceString = GetTypefaceString(TFace)
			Text = L.Text
			TextSize = L.TextSize
			TextColorInt = L.TextColor
			TextColorName = ColLUT.GetColorName(TextColorInt)
			TextGravity = L.Gravity
			TextGravityString = GetGravityString(TextGravity)
			If ReportedType = "RadioButton" Then 
				'Check for CustomView Objects
				If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
					CustomViewRBCount = CustomViewRBCount + 1
					Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
					ObjectName = "CVRadioButton"&NumberFormat(CustomViewRBCount,3,0)
					ObjectType = "RadioButton"
					'And add to the Map
					NamesMap.Put(ThisObject,ObjectName)
					ObjectsMap.Put(ObjectName,ObjectType)
				End If
				Dim RB As RadioButton = V
				BtnChecked = RB.Checked
			End If
			If ReportedType = "CheckBox" Then 
				'Check for CustomView Objects see notes on BALayout
				If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
					CustomViewCBCount = CustomViewCBCount + 1
					Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
					ObjectName = "CVCheckBox"&NumberFormat(CustomViewCBCount,3,0)
					ObjectType = "CheckBox"
					'And add to the Map
					NamesMap.Put(ThisObject,ObjectName)
					ObjectsMap.Put(ObjectName,ObjectType)
				End If
				Dim CB As CheckBox = V
				BtnChecked = CB.Checked
			End If
			If ReportedType = "ToggleButton" Then 
				'Check for CustomView Objects see notes on BALayout
				If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
					CustomViewTBCount = CustomViewTBCount + 1
					Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
					ObjectName = "CVToggleBar"&NumberFormat(CustomViewTBCount,3,0)
					ObjectType = "ToggleBar"
					'And add to the Map
					NamesMap.Put(ThisObject,ObjectName)
					ObjectsMap.Put(ObjectName,ObjectType)
				End If
				Dim TB As ToggleButton = V
				BtnChecked = TB.Checked
				TBTextOn = TB.TextOn
				TBTextOff = TB.TextOff
			End If
			
		Case "HorizontalScrollViewWrapper$MyHScrollView"
			'Check for CustomView Objects see notes on BALayout
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewHSVCount = CustomViewHSVCount + 1
				Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectName = "CVHorizontalScrollView"&NumberFormat(CustomViewHSVCount,3,0)
				ObjectType = "HorizontalScrollView"
				'And add to the Map so it's Children can find it.
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			End If
			Dim HSV As HorizontalScrollView = V
			SVInnerWidth = HSV.Panel.Width
			
			'Deal with this views children
			Dim P As Panel = HSV.Panel
			For I = 0 To P.NumberOfViews-1
				Dim TV As View = P.GetView(I)
				WriteCSVViews(Act,HSV,TV,NamesMap,ObjectsMap,mLevel+1)
				Children = Children & NamesMap.GetDefault(TV,"Custom View") & ","
			Next
		
		Case "ScrollViewWrapper$MyScrollView"
			'Check for CustomView Objects see notes on BALayout
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewSVCount = CustomViewSVCount + 1
				Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectName = "CVScrollView"&NumberFormat(CustomViewSVCount,3,0)
				ObjectType = "ScrollView"
				'And add to the Map so it's Children can find it.
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			End If
			Dim SV As ScrollView = V
			SVInnerHeight = SV.Panel.Height
			
			'Deal with this views children
			Dim P As Panel = SV.Panel
			For I = 0 To P.NumberOfViews-1
				Dim TV As View = P.GetView(I)
				WriteCSVViews(Act,SV,TV,NamesMap,ObjectsMap,mLevel+1)
				Children = Children & NamesMap.GetDefault(TV,"Custom View") & ","
			Next
			
		Case "WebView"
			'Check for CustomView Objects see notes on BALayout
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewWVCount = CustomViewWVCount + 1
				Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectName = "CVWebView"&NumberFormat(CustomViewWVCount,3,0)
				ObjectType = "WebView"
				'And add to the Map
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			End If
			Dim WV As WebView = V
			JSEnabled = WV.JavaScriptEnabled
			ZoomEnabled = WV.ZoomEnabled
		
		Case "B4ASpinner"
			'Check for CustomView Objects see notes on BALayout
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewSPCount = CustomViewSPCount + 1
				Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectName = "CVSpinner"&NumberFormat(CustomViewSPCount,3,0)
				ObjectType = "B4ASpinner"
				'And add to the Map
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			End If
			Dim SP As Spinner = V
			SPPrompt = SP.Prompt
			TextSize = SP.TextSize
			TextColorInt = SP.TextColor
			TextColorName = ColLUT.GetColorName(TextColorInt)
			
		Case "ProgressBar"
			'Check for CustomView Objects see notes on BALayout
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewPBCount = CustomViewPBCount + 1
				Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectName = "CVProgressBar"&NumberFormat(CustomViewPBCount,3,0)
				ObjectType = "ProgressBar"
				'And add to the Map
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			End If
			Dim PB As ProgressBar = V
			PBIndeterminate = PB.Indeterminate
			
		Case "SeekBar"
			'Check for CustomView Objects see notes on BALayout
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewSBCount = CustomViewSBCount + 1
				Parent = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectName = "CVSeekBar"&NumberFormat(CustomViewSBCount,3,0)
				ObjectType = "SeekBar"
				'And add to the Map
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			End If
			Dim SB As SeekBar = V
			SBMaxVal =SB.Max
			SBVal = SB.Value
			
		Case "TabHostWrapper$MyTabHost"
			'Deal with this views children
			Dim TH As TabHost = ThisObject
			Dim JO As JavaObject = TH
			Log(TH.TabCount)
			For j = 0 To TH.TabCount -1
				TH.CurrentTab = j
				Dim O As Object = JO.RunMethod("getCurrentView",Null)
				If O Is Panel Then
					Dim P As Panel = O    
					Children = Children & NamesMap.GetDefault(P,"CustomView") & ","
				End If
			Next
			
		Case "BALayout"
			'If we are here, It's a panel ReportedType = BALayout
			'It should be safe to assume that if the name is not in the NameMap, 
			'because we didn't add it to the map of know variables, that this is a CustomView that is either a compiled library
			'or that has private variables.
			If NamesMap.GetDefault(ThisObject,"NF") = "NF" Then
				CustomViewPanelCount = CustomViewPanelCount + 1
				ObjectName = "CustomViewPnl"&NumberFormat(CustomViewPanelCount,3,0)
				ObjectType = "CustomView"
				'And add to the Map so it's Children can find it.
				NamesMap.Put(ThisObject,ObjectName)
				ObjectsMap.Put(ObjectName,ObjectType)
			Else
				If V Is Panel Then
					Dim P As Panel = V
					For I = 0 To P.NumberOfViews-1
						Dim TV As View = P.GetView(I)
						WriteCSVViews(Act,P,TV,NamesMap,ObjectsMap,mLevel+1)
						Children = Children & NamesMap.GetDefault(TV,"Custom View") & ","
					Next
				End If
			End If
			
			
		
		Case Else
			LogColor("Object Not Found .... "&ReportedType&" "&ThisObject,Colors.Red)
			
	End Select
	
	'remove the last comma
	If Children <> "" Then Children = Children.SubString2(0,Children.Length-1)

	Dim Line As String
	Dim CSV As String = QUOTE&","&QUOTE
	
	Line = QUOTE & mLevel & CSV & ObjectName & CSV & ObjectType & CSV & ReportedType & CSV & Parent & CSV & Tag & CSV & X & CSV & Y & CSV & W & CSV & H & CSV 
	Line = Line & Enabled & CSV & Visible & CSV & BackgroundType & CSV & BackgroundColorInt & CSV & BackgroundColorName & CSV & BackgroundColorAlpha & CSV
	Line = Line & TFaceString & CSV & Text & CSV & TextSize & CSV & TextColorInt & CSV & TextColorName & CSV & TextGravity & CSV & TextGravityString & CSV
	Line = Line & TextHint & CSV & TextHintColor & CSV & TextHintColorName & CSV & TextInputType & CSV & TextInputTypeString & CSV & BtnChecked & CSV & TBTextOn & CSV 
	Line = Line & TBTextOff & CSV & SVInnerWidth & CSV & SVInnerHeight & CSV & JSEnabled & CSV & ZoomEnabled & CSV & SPPrompt & CSV & PBIndeterminate & CSV
	Line = Line & SBMaxVal & CSV & SBVal & CSV & Children & QUOTE
	
	OutList.Add(Line)
	'Record the item as processed
	ProcessedMap.Put(ObjectName,OutList.Size-1)
End Sub
Sub UpdateForCustomView(O As Object)

	
	Dim Parent As JavaObject = O
	Dim LastParent As Object
	Dim ParentStr As String
	Do While True
		Parent = Parent.RunMethod("getParent",Null)
		ParentStr = Parent
		If Not(ParentStr.StartsWith("(BALayout)")) Then
			Log("Non (BA..."&Parent)
			Exit
		End If
		Log(ParentStr)
		Log("Parent "&Parent)
		LastParent = Parent
	Loop
	Log("***")
End Sub
Sub GetGravityString(Grav As Int) As String

	Dim Gravstring As String

	If Grav = Gravity.FILL Then
		Return  "Fill"
	End If
	If Grav = 0 Then
		Return  "No_Gravity"
	End If
	If Grav = Gravity.CENTER Then
		Return "Center"
	End If
	If Grav >= 119 Then
		Gravstring = Gravstring &  "Fill"
		Grav=Grav - 119
		If Grav = 0 Then Return Gravstring
	End If
	If Grav >= 112 Then
		If Gravstring <> "" Then Gravstring = Gravstring & "|"
		Gravstring = Gravstring &  "Fill_Vertical"
		Grav=Grav - 112
		If Grav = 0 Then Return Gravstring
	End If
	If Grav >= Gravity.BOTTOM Then
		If Gravstring <> "" Then Gravstring = Gravstring & "|"
		Gravstring = Gravstring & "Bottom"
		Grav=Grav - Gravity.BOTTOM
		If Grav = 0 Then Return Gravstring
	End If
	If Grav >= Gravity.TOP Then
		If Gravstring <> "" Then Gravstring = Gravstring & "|"
		Gravstring = Gravstring &  "Top"
		Grav=Grav - Gravity.Top
		If Grav = 0 Then Return Gravstring
	End If	
	If Grav >= Gravity.CENTER_VERTICAL Then
		If Gravstring <> "" Then Gravstring = Gravstring & "|"
		Gravstring = Gravstring &  "Center_Vertical"
		Grav=Grav - Gravity.CENTER_VERTICAL
		If Grav = 0 Then Return Gravstring
	End If
	If Grav >= 7 Then
		If Gravstring <> "" Then Gravstring = Gravstring & "|"
		Gravstring = Gravstring &  "Fill_Horizontal"
		Grav=Grav - 7
		If Grav = 0 Then Return Gravstring
	End If	
	If Grav >= Gravity.RIGHT Then
		If Gravstring <> "" Then Gravstring = Gravstring & "|"
		Gravstring = Gravstring &  "Right"
		Grav=Grav - Gravity.RIGHT
		If Grav = 0 Then Return Gravstring
	End If
	If Grav >= Gravity.LEFT Then
		If Gravstring <> "" Then Gravstring = Gravstring & "|"
		Gravstring = Gravstring &  "Left"
		Grav=Grav - Gravity.LEFT
		If Grav = 0 Then Return Gravstring
	End If
	If Grav >= Gravity.CENTER_HORIZONTAL Then
		If Gravstring <> "" Then Gravstring = Gravstring & "|"
		Gravstring = Gravstring &  "Center_Horizontal"
		Grav=Grav - Gravity.CENTER_HORIZONTAL
		If Grav = 0 Then Return Gravstring
	End If
	If Gravstring = "" Then Return "Unknown"
	
	Return Gravstring
End Sub
Sub GetTypefaceString(TF As Typeface) As String

	'DEFAULT_BOLD font may not be bold, dependant on implementation.
	'Need to check style as well.
	
	Dim TFString As String
	
	Dim JO As JavaObject
	JO.InitializeStatic("android.graphics.Typeface")
	Dim Default As Typeface = JO.GetField("DEFAULT")
	Dim Default_Bold As Typeface = JO.GetField("DEFAULT_BOLD")
	Dim Monospace As Typeface = JO.GetField("MONOSPACE")
	Dim Sans_Serif As Typeface = JO.GetField("SANS_SERIF")
	Dim Serif As Typeface = JO.GetField("SERIF")
	
	'Styles
	Dim Bold As Int = JO.GetField("BOLD")
	Dim Bold_Italic As Int = JO.GetField("BOLD_ITALIC")
	Dim Italic As Int = JO.GetField("ITALIC")
	Dim Normal As Int = JO.GetField("NORMAL")
	
	Dim JO As JavaObject = TF
	Dim Style As Int = JO.RunMethod("getStyle",Null)
	
	
	Select TF
	
		Case Default
			TFString = "Default"
		
		Case Default_Bold
			TFString = "Default_Bold"
			
		Case Monospace
			TFString = "Monospace"
		
		Case Sans_Serif
			TFString = "Sans_Serif"
		
		Case Serif
			TFString = "Serif"
			
		Case Else
			TFString = "User Defined"
			
	End Select
	
	Select Style
	
		Case Bold
			TFString = TFString & " : Bold"
		
		Case Bold_Italic
			TFString = TFString &" : Bold_Italic"
			
		Case Italic
			TFString = TFString &" : Italic"
			
		Case Normal
			TFString = TFString &" : Normal"
		
	End Select
	
	
	Return TFString
End Sub
Sub WriteCSVfile(FilePath As String, FileName As String) As Boolean

	If FileName = "" Then FileName = "OV.csv"

	Dim FD As FileDialog
	
	FD.FilePath = FilePath
	FD.KeyboardPopUp = False
	FD.FileFilter = ".csv"
	FD.ChosenName = FileName
	Do While True
		FD.Show("Save output As csv File","Save","Cancel","",Null)
		Log(FD.Response)
		If FD.Response = DialogResponse.CANCEL Then Return False
		If FD.Response = DialogResponse.POSITIVE Then Exit
	Loop
	
	Options.SaveFileName = FD.ChosenName
	Options.SaveFilePath = FD.FilePath
	If Not(Options.SaveFileName.EndsWith(".csv")) Then Options.SaveFileName = Options.SaveFileName&".csv"
	
	Dim TW As TextWriter
	TW.Initialize(File.OpenOutput(FD.FilePath,Options.SaveFileName,False))
	TW.WriteList(OutList)
	TW.Flush
	TW.Close

	Log("Saved")
	Return True
End Sub
Sub ToLog (V As View,NamesMap As Map,ObjectsMap As Map,mLevel As Int)
		
		Dim ObjectName As String
		Dim ObjectType As String
		Dim ViewToString As String = V
		Dim ViewTostringName As String = ViewToString.SubString2(0,ViewToString.IndexOf(":"))
		
		ObjectName = NamesMap.Get(V)
		ObjectType = ObjectsMap.GetDefault(ObjectName,"***Not Found***")		
		
		
		Log("*******************************")
		Log("Level "&mLevel)
		LogColor(ObjectName,Colors.Magenta)
		LogColor(ObjectType,Colors.Cyan)
		Log(V)
		LogColor(V.Left&" "&V.Top&" "&V.Width&" "&V.Height,Colors.Red)
		LogColor(V.Tag,Colors.Blue)
End Sub
